/* WindowOverview.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowOverview.vala, do not modify */

/*
 * Copyright 2012 Tom Beckmann
 * Copyright 2012 Rico Tzschichholz
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <clutter/clutter.h>
#include "gala.h"
#include <glib-object.h>
#include <glib.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-workspace-manager.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include <meta/keybindings.h>
#include <mtk/mtk.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>

#define GALA_WINDOW_OVERVIEW_BORDER 10
#define GALA_WINDOW_OVERVIEW_TOP_GAP 30
#define GALA_WINDOW_OVERVIEW_BOTTOM_GAP 100
#define GALA_MULTITASKING_VIEW_ANIMATION_DURATION 250
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_OVERVIEW (gala_window_overview_get_type ())
#define GALA_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview))
#define GALA_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))
#define GALA_IS_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_IS_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_WINDOW_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))

typedef struct _GalaWindowOverview GalaWindowOverview;
typedef struct _GalaWindowOverviewClass GalaWindowOverviewClass;
typedef struct _GalaWindowOverviewPrivate GalaWindowOverviewPrivate;

#define GALA_TYPE_WINDOW_CLONE_CONTAINER (gala_window_clone_container_get_type ())
#define GALA_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer))
#define GALA_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))
#define GALA_IS_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_IS_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_WINDOW_CLONE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))

typedef struct _GalaWindowCloneContainer GalaWindowCloneContainer;
typedef struct _GalaWindowCloneContainerClass GalaWindowCloneContainerClass;
enum  {
	GALA_WINDOW_OVERVIEW_0_PROPERTY,
	GALA_WINDOW_OVERVIEW_WM_PROPERTY,
	GALA_WINDOW_OVERVIEW_NUM_PROPERTIES
};
static GParamSpec* gala_window_overview_properties[GALA_WINDOW_OVERVIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;
typedef struct _Block70Data Block70Data;

struct _GalaWindowOverview {
	ClutterActor parent_instance;
	GalaWindowOverviewPrivate * priv;
};

struct _GalaWindowOverviewClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowOverviewPrivate {
	GalaWindowManager* _wm;
	GalaModalProxy* modal_proxy;
	GList* workspaces;
	GalaWindowCloneContainer* window_clone_container;
};

struct _Block70Data {
	int _ref_count_;
	GalaWindowOverview* self;
	MetaWindow* window;
};

static gint GalaWindowOverview_private_offset;
static gpointer gala_window_overview_parent_class = NULL;
static GalaActivatableComponentIface * gala_window_overview_gala_activatable_component_parent_iface = NULL;

VALA_EXTERN GType gala_window_overview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowOverview, g_object_unref)
VALA_EXTERN GType gala_window_clone_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowCloneContainer, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GalaWindowOverview* gala_window_overview_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowOverview* gala_window_overview_construct (GType object_type,
                                                    GalaWindowManager* wm);
static gboolean gala_window_overview_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static gboolean gala_window_overview_real_button_release_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_window_overview_real_is_opened (GalaActivatableComponent* base);
static void gala_window_overview_real_open (GalaActivatableComponent* base,
                                     GHashTable* hints);
VALA_EXTERN GalaWindowManager* gala_window_overview_get_wm (GalaWindowOverview* self);
static guint64* _variant_get1 (GVariant* value,
                        gint* result_length1);
static gboolean _vala_uint64_array_contains (guint64 * stack,
                                      gssize stack_length,
                                      const guint64 needle);
static void gala_window_overview_add_window (GalaWindowOverview* self,
                                      MetaWindow* window);
static void _gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self);
static void gala_window_overview_remove_window (GalaWindowOverview* self,
                                         MetaWindow* window);
static void _gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                        MetaWindow* object,
                                                                        gpointer self);
static void gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                               gint num,
                                               MetaWindow* window);
static void _gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                                 gint object,
                                                                                 MetaWindow* p0,
                                                                                 gpointer self);
static gboolean gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                                 MetaKeyBinding* binding);
static gboolean _gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                         gpointer self);
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_new (GalaWindowManager* wm,
                                                           GalaGestureTracker* gesture_tracker,
                                                           gfloat scale,
                                                           gboolean overview_mode);
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_construct (GType object_type,
                                                                 GalaWindowManager* wm,
                                                                 GalaGestureTracker* gesture_tracker,
                                                                 gfloat scale,
                                                                 gboolean overview_mode);
VALA_EXTERN void gala_window_clone_container_set_padding_top (GalaWindowCloneContainer* self,
                                                  gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_left (GalaWindowCloneContainer* self,
                                                   gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_right (GalaWindowCloneContainer* self,
                                                    gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_bottom (GalaWindowCloneContainer* self,
                                                     gint value);
static void gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                          MetaWindow* window);
static void _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                       MetaWindow* window,
                                                                                       gpointer self);
static void _____lambda153_ (GalaWindowOverview* self);
static void ______lambda153__gala_window_clone_container_requested_close (GalaWindowCloneContainer* _sender,
                                                                   gpointer self);
VALA_EXTERN void gala_window_clone_container_add_window (GalaWindowCloneContainer* self,
                                             MetaWindow* window);
VALA_EXTERN void gala_window_clone_container_open (GalaWindowCloneContainer* self,
                                       MetaWindow* selected_window,
                                       gboolean with_gesture,
                                       gboolean is_cancel_animation);
static void gala_window_overview_restack_windows (GalaWindowOverview* self);
VALA_EXTERN void gala_window_clone_container_restack_windows (GalaWindowCloneContainer* self);
VALA_EXTERN void gala_window_clone_container_remove_window (GalaWindowCloneContainer* self,
                                                MetaWindow* window);
static Block70Data* block70_data_ref (Block70Data* _data70_);
static void block70_data_unref (void * _userdata_);
static gboolean ___lambda152_ (Block70Data* _data70_);
static gboolean ____lambda152__gsource_func (gpointer self);
static void gala_window_overview_real_close (GalaActivatableComponent* base,
                                      GHashTable* hints);
VALA_EXTERN void gala_window_clone_container_close (GalaWindowCloneContainer* self,
                                        gboolean with_gesture,
                                        gboolean is_cancel_animation);
static gboolean __lambda151_ (GalaWindowOverview* self);
static void gala_window_overview_cleanup (GalaWindowOverview* self);
static gboolean ___lambda151__gsource_func (gpointer self);
static void gala_window_overview_set_wm (GalaWindowOverview* self,
                                  GalaWindowManager* value);
static GObject * gala_window_overview_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void gala_window_overview_finalize (GObject * obj);
static GType gala_window_overview_get_type_once (void);
static void _vala_gala_window_overview_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_overview_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_window_overview_get_instance_private (GalaWindowOverview* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowOverview_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 17 "../src/Widgets/WindowOverview.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 238 "WindowOverview.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 17 "../src/Widgets/WindowOverview.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 246 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowOverview * self = NULL;
#line 20 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 21 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) g_object_new (object_type, "wm", wm, NULL);
#line 20 "../src/Widgets/WindowOverview.vala"
	return self;
#line 260 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_new (GalaWindowManager* wm)
{
#line 20 "../src/Widgets/WindowOverview.vala"
	return gala_window_overview_construct (GALA_TYPE_WINDOW_OVERVIEW, wm);
#line 268 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowOverview * self;
	GalaWindowCloneContainer* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 31 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 31 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 35 "../src/Widgets/WindowOverview.vala"
	if (!gala_activatable_component_is_opened ((GalaActivatableComponent*) self)) {
#line 36 "../src/Widgets/WindowOverview.vala"
		result = CLUTTER_EVENT_PROPAGATE;
#line 36 "../src/Widgets/WindowOverview.vala"
		return result;
#line 289 "WindowOverview.c"
	}
#line 39 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->window_clone_container;
#line 39 "../src/Widgets/WindowOverview.vala"
	g_signal_emit_by_name ((ClutterActor*) _tmp0_, "key-press-event", event, &_tmp1_);
#line 39 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 39 "../src/Widgets/WindowOverview.vala"
	return result;
#line 299 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_button_release_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaWindowOverview * self;
	gboolean result;
#line 43 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 43 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 47 "../src/Widgets/WindowOverview.vala"
	if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 48 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 316 "WindowOverview.c"
	}
#line 51 "../src/Widgets/WindowOverview.vala"
	result = CLUTTER_EVENT_STOP;
#line 51 "../src/Widgets/WindowOverview.vala"
	return result;
#line 322 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
gala_window_overview_real_is_opened (GalaActivatableComponent* base)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 57 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 58 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 58 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 58 "../src/Widgets/WindowOverview.vala"
	return result;
#line 345 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 68 "../src/Widgets/WindowOverview.vala"
	return self ? g_object_ref (self) : NULL;
#line 356 "WindowOverview.c"
}

static guint64*
_variant_get1 (GVariant* value,
               gint* result_length1)
{
	guint64* _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_tmp0_ = g_new (guint64, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
#line 73 "../src/Widgets/WindowOverview.vala"
	g_variant_iter_init (&_tmp1_, value);
#line 73 "../src/Widgets/WindowOverview.vala"
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
#line 73 "../src/Widgets/WindowOverview.vala"
		if (_tmp0__size == _tmp0__length) {
#line 73 "../src/Widgets/WindowOverview.vala"
			_tmp0__size = 2 * _tmp0__size;
#line 73 "../src/Widgets/WindowOverview.vala"
			_tmp0_ = g_renew (guint64, _tmp0_, _tmp0__size + 1);
#line 383 "WindowOverview.c"
		}
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp0_[_tmp0__length++] = g_variant_get_uint64 (_tmp2_);
#line 73 "../src/Widgets/WindowOverview.vala"
		g_variant_unref (_tmp2_);
#line 389 "WindowOverview.c"
	}
#line 73 "../src/Widgets/WindowOverview.vala"
	*result_length1 = _tmp0__length1;
#line 73 "../src/Widgets/WindowOverview.vala"
	return _tmp0_;
#line 395 "WindowOverview.c"
}

static gboolean
_vala_uint64_array_contains (guint64 * stack,
                             gssize stack_length,
                             const guint64 needle)
{
	gssize i;
#line 87 "../src/Widgets/WindowOverview.vala"
	for (i = 0; i < stack_length; i++) {
#line 87 "../src/Widgets/WindowOverview.vala"
		if (needle == stack[i]) {
#line 87 "../src/Widgets/WindowOverview.vala"
			return TRUE;
#line 410 "WindowOverview.c"
		}
	}
#line 87 "../src/Widgets/WindowOverview.vala"
	return FALSE;
#line 415 "WindowOverview.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5297 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5297 "glib-2.0.vapi"
	return result;
#line 426 "WindowOverview.c"
}

static void
_gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                              MetaWindow* object,
                                                              gpointer self)
{
#line 110 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_add_window ((GalaWindowOverview*) self, object);
#line 436 "WindowOverview.c"
}

static void
_gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self)
{
#line 111 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_remove_window ((GalaWindowOverview*) self, object);
#line 446 "WindowOverview.c"
}

static void
_gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                            gint object,
                                                                            MetaWindow* p0,
                                                                            gpointer self)
{
#line 114 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_window_left_monitor ((GalaWindowOverview*) self, object, p0);
#line 457 "WindowOverview.c"
}

static gboolean
_gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                gpointer self)
{
	gboolean result;
	result = gala_window_overview_keybinding_filter ((GalaWindowOverview*) self, binding);
#line 119 "../src/Widgets/WindowOverview.vala"
	return result;
#line 468 "WindowOverview.c"
}

static void
_gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                  MetaWindow* window,
                                                                                  gpointer self)
{
#line 137 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_thumb_selected ((GalaWindowOverview*) self, window);
#line 478 "WindowOverview.c"
}

static void
_____lambda153_ (GalaWindowOverview* self)
{
#line 138 "../src/Widgets/WindowOverview.vala"
	gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 486 "WindowOverview.c"
}

static void
______lambda153__gala_window_clone_container_requested_close (GalaWindowCloneContainer* _sender,
                                                              gpointer self)
{
#line 138 "../src/Widgets/WindowOverview.vala"
	_____lambda153_ ((GalaWindowOverview*) self);
#line 495 "WindowOverview.c"
}

static void
gala_window_overview_real_open (GalaActivatableComponent* base,
                                GHashTable* hints)
{
	GalaWindowOverview * self;
	MetaWorkspaceManager* manager = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	GList* _tmp4_;
	guint64* window_ids = NULL;
	gint window_ids_length1;
	gint _window_ids_size_;
	gboolean _tmp7_ = FALSE;
	GList* windows = NULL;
	GList* _tmp10_;
	GList* _tmp47_;
	GList* _tmp48_;
	GalaWindowManager* _tmp52_;
	MetaDisplay* _tmp53_;
	GalaWindowManager* _tmp54_;
	GalaModalProxy* _tmp55_;
	GalaModalProxy* _tmp56_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp57_;
	MetaDisplay* _tmp58_;
	GList* _tmp74_;
#line 64 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 65 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 65 "../src/Widgets/WindowOverview.vala"
	self->priv->workspaces = NULL;
#line 66 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 66 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 66 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 66 "../src/Widgets/WindowOverview.vala"
	manager = _tmp2_;
#line 67 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = manager;
#line 67 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_workspace_manager_get_workspaces (_tmp3_);
#line 544 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 67 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp4_;
#line 67 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 552 "WindowOverview.c"
			MetaWorkspace* workspace = NULL;
#line 67 "../src/Widgets/WindowOverview.vala"
			workspace = (MetaWorkspace*) workspace_it->data;
#line 556 "WindowOverview.c"
			{
				MetaWorkspace* _tmp5_;
				MetaWorkspace* _tmp6_;
#line 68 "../src/Widgets/WindowOverview.vala"
				_tmp5_ = workspace;
#line 68 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = _g_object_ref0 (_tmp5_);
#line 68 "../src/Widgets/WindowOverview.vala"
				self->priv->workspaces = g_list_append (self->priv->workspaces, _tmp6_);
#line 566 "WindowOverview.c"
			}
		}
	}
#line 71 "../src/Widgets/WindowOverview.vala"
	window_ids = NULL;
#line 71 "../src/Widgets/WindowOverview.vala"
	window_ids_length1 = 0;
#line 71 "../src/Widgets/WindowOverview.vala"
	_window_ids_size_ = window_ids_length1;
#line 72 "../src/Widgets/WindowOverview.vala"
	if (hints != NULL) {
#line 72 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = g_hash_table_contains (hints, "windows");
#line 580 "WindowOverview.c"
	} else {
#line 72 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = FALSE;
#line 584 "WindowOverview.c"
	}
#line 72 "../src/Widgets/WindowOverview.vala"
	if (_tmp7_) {
#line 588 "WindowOverview.c"
		gconstpointer _tmp8_;
		guint64* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = g_hash_table_lookup (hints, "windows");
#line 73 "../src/Widgets/WindowOverview.vala"
		_tmp9_ = _variant_get1 ((GVariant*) _tmp8_, &_tmp9__length1);
#line 73 "../src/Widgets/WindowOverview.vala"
		window_ids = (g_free (window_ids), NULL);
#line 73 "../src/Widgets/WindowOverview.vala"
		window_ids = _tmp9_;
#line 73 "../src/Widgets/WindowOverview.vala"
		window_ids_length1 = _tmp9__length1;
#line 73 "../src/Widgets/WindowOverview.vala"
		_window_ids_size_ = window_ids_length1;
#line 604 "WindowOverview.c"
	}
#line 76 "../src/Widgets/WindowOverview.vala"
	windows = NULL;
#line 77 "../src/Widgets/WindowOverview.vala"
	_tmp10_ = self->priv->workspaces;
#line 610 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 77 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp10_;
#line 77 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 618 "WindowOverview.c"
			MetaWorkspace* _tmp11_;
			MetaWorkspace* workspace = NULL;
#line 77 "../src/Widgets/WindowOverview.vala"
			_tmp11_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 77 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp11_;
#line 625 "WindowOverview.c"
			{
				MetaWorkspace* _tmp12_;
				GList* _tmp13_;
#line 78 "../src/Widgets/WindowOverview.vala"
				_tmp12_ = workspace;
#line 78 "../src/Widgets/WindowOverview.vala"
				_tmp13_ = meta_workspace_list_windows (_tmp12_);
#line 633 "WindowOverview.c"
				{
					GList* window_collection = NULL;
					GList* window_it = NULL;
#line 78 "../src/Widgets/WindowOverview.vala"
					window_collection = _tmp13_;
#line 78 "../src/Widgets/WindowOverview.vala"
					for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 641 "WindowOverview.c"
						MetaWindow* window = NULL;
#line 78 "../src/Widgets/WindowOverview.vala"
						window = (MetaWindow*) window_it->data;
#line 645 "WindowOverview.c"
						{
							gboolean _tmp14_ = FALSE;
							MetaWindow* _tmp15_;
							MetaWindowType _tmp16_;
							MetaWindowType _tmp17_;
							gboolean _tmp21_ = FALSE;
							gboolean _tmp22_ = FALSE;
							gboolean _tmp23_ = FALSE;
							MetaWindow* _tmp24_;
							MetaWindowType _tmp25_;
							MetaWindowType _tmp26_;
							gboolean _tmp38_ = FALSE;
							MetaWindow* _tmp39_;
							gboolean _tmp40_;
							gboolean _tmp41_;
							MetaWindow* _tmp45_;
							MetaWindow* _tmp46_;
#line 79 "../src/Widgets/WindowOverview.vala"
							_tmp15_ = window;
#line 79 "../src/Widgets/WindowOverview.vala"
							_tmp16_ = meta_window_get_window_type (_tmp15_);
#line 79 "../src/Widgets/WindowOverview.vala"
							_tmp17_ = _tmp16_;
#line 79 "../src/Widgets/WindowOverview.vala"
							if (_tmp17_ == META_WINDOW_DOCK) {
#line 79 "../src/Widgets/WindowOverview.vala"
								_tmp14_ = TRUE;
#line 673 "WindowOverview.c"
							} else {
								MetaWindow* _tmp18_;
								MetaWindowType _tmp19_;
								MetaWindowType _tmp20_;
#line 80 "../src/Widgets/WindowOverview.vala"
								_tmp18_ = window;
#line 80 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = meta_window_get_window_type (_tmp18_);
#line 80 "../src/Widgets/WindowOverview.vala"
								_tmp20_ = _tmp19_;
#line 80 "../src/Widgets/WindowOverview.vala"
								_tmp14_ = _tmp20_ == META_WINDOW_NOTIFICATION;
#line 686 "WindowOverview.c"
							}
#line 79 "../src/Widgets/WindowOverview.vala"
							if (_tmp14_) {
#line 81 "../src/Widgets/WindowOverview.vala"
								continue;
#line 692 "WindowOverview.c"
							}
#line 84 "../src/Widgets/WindowOverview.vala"
							_tmp24_ = window;
#line 84 "../src/Widgets/WindowOverview.vala"
							_tmp25_ = meta_window_get_window_type (_tmp24_);
#line 84 "../src/Widgets/WindowOverview.vala"
							_tmp26_ = _tmp25_;
#line 84 "../src/Widgets/WindowOverview.vala"
							if (_tmp26_ != META_WINDOW_NORMAL) {
#line 702 "WindowOverview.c"
								MetaWindow* _tmp27_;
								MetaWindowType _tmp28_;
								MetaWindowType _tmp29_;
#line 85 "../src/Widgets/WindowOverview.vala"
								_tmp27_ = window;
#line 85 "../src/Widgets/WindowOverview.vala"
								_tmp28_ = meta_window_get_window_type (_tmp27_);
#line 85 "../src/Widgets/WindowOverview.vala"
								_tmp29_ = _tmp28_;
#line 85 "../src/Widgets/WindowOverview.vala"
								_tmp23_ = _tmp29_ != META_WINDOW_DIALOG;
#line 714 "WindowOverview.c"
							} else {
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp23_ = FALSE;
#line 718 "WindowOverview.c"
							}
#line 84 "../src/Widgets/WindowOverview.vala"
							if (_tmp23_) {
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp22_ = TRUE;
#line 724 "WindowOverview.c"
							} else {
								MetaWindow* _tmp30_;
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp30_ = window;
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp22_ = meta_window_is_attached_dialog (_tmp30_);
#line 731 "WindowOverview.c"
							}
#line 84 "../src/Widgets/WindowOverview.vala"
							if (_tmp22_) {
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp21_ = TRUE;
#line 737 "WindowOverview.c"
							} else {
								gboolean _tmp31_ = FALSE;
								guint64* _tmp32_;
								gint _tmp32__length1;
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp32_ = window_ids;
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp32__length1 = window_ids_length1;
#line 87 "../src/Widgets/WindowOverview.vala"
								if (_tmp32_ != NULL) {
#line 748 "WindowOverview.c"
									MetaWindow* _tmp33_;
									guint64* _tmp34_;
									gint _tmp34__length1;
#line 87 "../src/Widgets/WindowOverview.vala"
									_tmp33_ = window;
#line 87 "../src/Widgets/WindowOverview.vala"
									_tmp34_ = window_ids;
#line 87 "../src/Widgets/WindowOverview.vala"
									_tmp34__length1 = window_ids_length1;
#line 87 "../src/Widgets/WindowOverview.vala"
									_tmp31_ = !_vala_uint64_array_contains (_tmp34_, _tmp34__length1, meta_window_get_id (_tmp33_));
#line 760 "WindowOverview.c"
								} else {
#line 87 "../src/Widgets/WindowOverview.vala"
									_tmp31_ = FALSE;
#line 764 "WindowOverview.c"
								}
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp21_ = _tmp31_;
#line 768 "WindowOverview.c"
							}
#line 84 "../src/Widgets/WindowOverview.vala"
							if (_tmp21_) {
#line 772 "WindowOverview.c"
								MetaWindowActor* actor = NULL;
								MetaWindow* _tmp35_;
								GObject* _tmp36_;
								MetaWindowActor* _tmp37_;
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp35_ = window;
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp36_ = meta_window_get_compositor_private (_tmp35_);
#line 89 "../src/Widgets/WindowOverview.vala"
								actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, meta_window_actor_get_type (), MetaWindowActor);
#line 90 "../src/Widgets/WindowOverview.vala"
								_tmp37_ = actor;
#line 90 "../src/Widgets/WindowOverview.vala"
								clutter_actor_hide ((ClutterActor*) _tmp37_);
#line 92 "../src/Widgets/WindowOverview.vala"
								continue;
#line 789 "WindowOverview.c"
							}
#line 97 "../src/Widgets/WindowOverview.vala"
							_tmp39_ = window;
#line 97 "../src/Widgets/WindowOverview.vala"
							g_object_get (_tmp39_, "on-all-workspaces", &_tmp40_, NULL);
#line 97 "../src/Widgets/WindowOverview.vala"
							_tmp41_ = _tmp40_;
#line 97 "../src/Widgets/WindowOverview.vala"
							if (_tmp41_) {
#line 799 "WindowOverview.c"
								MetaWindow* _tmp42_;
								MetaWorkspace* _tmp43_;
								MetaWorkspace* _tmp44_;
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp42_ = window;
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp43_ = meta_window_get_workspace (_tmp42_);
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp44_ = workspace;
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp38_ = _tmp43_ != _tmp44_;
#line 811 "WindowOverview.c"
							} else {
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp38_ = FALSE;
#line 815 "WindowOverview.c"
							}
#line 97 "../src/Widgets/WindowOverview.vala"
							if (_tmp38_) {
#line 98 "../src/Widgets/WindowOverview.vala"
								continue;
#line 821 "WindowOverview.c"
							}
#line 101 "../src/Widgets/WindowOverview.vala"
							_tmp45_ = window;
#line 101 "../src/Widgets/WindowOverview.vala"
							_tmp46_ = _g_object_ref0 (_tmp45_);
#line 101 "../src/Widgets/WindowOverview.vala"
							windows = g_list_append (windows, _tmp46_);
#line 829 "WindowOverview.c"
						}
					}
#line 78 "../src/Widgets/WindowOverview.vala"
					(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 834 "WindowOverview.c"
				}
#line 77 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 838 "WindowOverview.c"
			}
		}
	}
#line 105 "../src/Widgets/WindowOverview.vala"
	_tmp47_ = windows;
#line 105 "../src/Widgets/WindowOverview.vala"
	if (vala_g_list_is_empty (_tmp47_)) {
#line 106 "../src/Widgets/WindowOverview.vala"
		(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 106 "../src/Widgets/WindowOverview.vala"
		window_ids = (g_free (window_ids), NULL);
#line 106 "../src/Widgets/WindowOverview.vala"
		return;
#line 852 "WindowOverview.c"
	}
#line 109 "../src/Widgets/WindowOverview.vala"
	_tmp48_ = self->priv->workspaces;
#line 856 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 109 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp48_;
#line 109 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 864 "WindowOverview.c"
			MetaWorkspace* _tmp49_;
			MetaWorkspace* workspace = NULL;
#line 109 "../src/Widgets/WindowOverview.vala"
			_tmp49_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 109 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp49_;
#line 871 "WindowOverview.c"
			{
				MetaWorkspace* _tmp50_;
				MetaWorkspace* _tmp51_;
#line 110 "../src/Widgets/WindowOverview.vala"
				_tmp50_ = workspace;
#line 110 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp50_, "window-added", (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self, 0);
#line 111 "../src/Widgets/WindowOverview.vala"
				_tmp51_ = workspace;
#line 111 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp51_, "window-removed", (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self, 0);
#line 109 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 885 "WindowOverview.c"
			}
		}
	}
#line 114 "../src/Widgets/WindowOverview.vala"
	_tmp52_ = self->priv->_wm;
#line 114 "../src/Widgets/WindowOverview.vala"
	_tmp53_ = meta_plugin_get_display ((MetaPlugin*) _tmp52_);
#line 114 "../src/Widgets/WindowOverview.vala"
	g_signal_connect_object (_tmp53_, "window-left-monitor", (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self, 0);
#line 116 "../src/Widgets/WindowOverview.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 118 "../src/Widgets/WindowOverview.vala"
	_tmp54_ = self->priv->_wm;
#line 118 "../src/Widgets/WindowOverview.vala"
	_tmp55_ = gala_window_manager_push_modal (_tmp54_, (ClutterActor*) self);
#line 118 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 118 "../src/Widgets/WindowOverview.vala"
	self->priv->modal_proxy = _tmp55_;
#line 119 "../src/Widgets/WindowOverview.vala"
	_tmp56_ = self->priv->modal_proxy;
#line 119 "../src/Widgets/WindowOverview.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp56_, _gala_window_overview_keybinding_filter_gala_keybinding_filter, self);
#line 121 "../src/Widgets/WindowOverview.vala"
	_tmp57_ = self->priv->_wm;
#line 121 "../src/Widgets/WindowOverview.vala"
	_tmp58_ = meta_plugin_get_display ((MetaPlugin*) _tmp57_);
#line 121 "../src/Widgets/WindowOverview.vala"
	display = _tmp58_;
#line 915 "WindowOverview.c"
	{
		gint i = 0;
#line 123 "../src/Widgets/WindowOverview.vala"
		i = 0;
#line 920 "WindowOverview.c"
		{
			gboolean _tmp59_ = FALSE;
#line 123 "../src/Widgets/WindowOverview.vala"
			_tmp59_ = TRUE;
#line 123 "../src/Widgets/WindowOverview.vala"
			while (TRUE) {
#line 927 "WindowOverview.c"
				MetaDisplay* _tmp61_;
				MtkRectangle geometry = {0};
				MetaDisplay* _tmp62_;
				MtkRectangle _tmp63_ = {0};
				gfloat scale = 0.0F;
				MetaDisplay* _tmp64_;
				GalaWindowManager* _tmp65_;
				MtkRectangle _tmp66_;
				MtkRectangle _tmp67_;
				MtkRectangle _tmp68_;
				MtkRectangle _tmp69_;
				GalaWindowCloneContainer* _tmp70_ = NULL;
				GalaWindowCloneContainer* _tmp71_;
				GalaWindowCloneContainer* _tmp72_;
				GalaWindowCloneContainer* _tmp73_;
#line 123 "../src/Widgets/WindowOverview.vala"
				if (!_tmp59_) {
#line 945 "WindowOverview.c"
					gint _tmp60_;
#line 123 "../src/Widgets/WindowOverview.vala"
					_tmp60_ = i;
#line 123 "../src/Widgets/WindowOverview.vala"
					i = _tmp60_ + 1;
#line 951 "WindowOverview.c"
				}
#line 123 "../src/Widgets/WindowOverview.vala"
				_tmp59_ = FALSE;
#line 123 "../src/Widgets/WindowOverview.vala"
				_tmp61_ = display;
#line 123 "../src/Widgets/WindowOverview.vala"
				if (!(i < meta_display_get_n_monitors (_tmp61_))) {
#line 123 "../src/Widgets/WindowOverview.vala"
					break;
#line 961 "WindowOverview.c"
				}
#line 124 "../src/Widgets/WindowOverview.vala"
				_tmp62_ = display;
#line 124 "../src/Widgets/WindowOverview.vala"
				meta_display_get_monitor_geometry (_tmp62_, i, &_tmp63_);
#line 124 "../src/Widgets/WindowOverview.vala"
				geometry = _tmp63_;
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp64_ = display;
#line 125 "../src/Widgets/WindowOverview.vala"
				scale = meta_display_get_monitor_scale (_tmp64_, i);
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp65_ = self->priv->_wm;
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp66_ = geometry;
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp67_ = geometry;
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp68_ = geometry;
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp69_ = geometry;
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp70_ = gala_window_clone_container_new (_tmp65_, NULL, scale, TRUE);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_top (_tmp70_, GALA_WINDOW_OVERVIEW_TOP_GAP);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_left (_tmp70_, GALA_WINDOW_OVERVIEW_BORDER);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_right (_tmp70_, GALA_WINDOW_OVERVIEW_BORDER);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_bottom (_tmp70_, GALA_WINDOW_OVERVIEW_BOTTOM_GAP);
#line 127 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_width ((ClutterActor*) _tmp70_, (gfloat) _tmp66_.width);
#line 127 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_height ((ClutterActor*) _tmp70_, (gfloat) _tmp67_.height);
#line 127 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_x ((ClutterActor*) _tmp70_, (gfloat) _tmp68_.x);
#line 127 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_y ((ClutterActor*) _tmp70_, (gfloat) _tmp69_.y);
#line 127 "../src/Widgets/WindowOverview.vala"
				g_object_ref_sink (_tmp70_);
#line 127 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (self->priv->window_clone_container);
#line 127 "../src/Widgets/WindowOverview.vala"
				self->priv->window_clone_container = _tmp70_;
#line 137 "../src/Widgets/WindowOverview.vala"
				_tmp71_ = self->priv->window_clone_container;
#line 137 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp71_, "window-selected", (GCallback) _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected, self, 0);
#line 138 "../src/Widgets/WindowOverview.vala"
				_tmp72_ = self->priv->window_clone_container;
#line 138 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp72_, "requested-close", (GCallback) ______lambda153__gala_window_clone_container_requested_close, self, 0);
#line 140 "../src/Widgets/WindowOverview.vala"
				_tmp73_ = self->priv->window_clone_container;
#line 140 "../src/Widgets/WindowOverview.vala"
				clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp73_);
#line 1019 "WindowOverview.c"
			}
		}
	}
#line 143 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 145 "../src/Widgets/WindowOverview.vala"
	_tmp74_ = windows;
#line 1027 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 145 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp74_;
#line 145 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1035 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 145 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1039 "WindowOverview.c"
			{
				MetaWindowActor* actor = NULL;
				MetaWindow* _tmp75_;
				GObject* _tmp76_;
				MetaWindowActor* _tmp77_;
				GalaWindowCloneContainer* container = NULL;
				MetaWindow* _tmp78_;
				ClutterActor* _tmp79_;
				GalaWindowCloneContainer* _tmp80_;
				GalaWindowCloneContainer* _tmp81_;
				MetaWindow* _tmp82_;
				GalaWindowCloneContainer* _tmp83_;
				MetaDisplay* _tmp84_;
				MetaWindow* _tmp85_;
#line 146 "../src/Widgets/WindowOverview.vala"
				_tmp75_ = window;
#line 146 "../src/Widgets/WindowOverview.vala"
				_tmp76_ = meta_window_get_compositor_private (_tmp75_);
#line 146 "../src/Widgets/WindowOverview.vala"
				actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, meta_window_actor_get_type (), MetaWindowActor);
#line 147 "../src/Widgets/WindowOverview.vala"
				_tmp77_ = actor;
#line 147 "../src/Widgets/WindowOverview.vala"
				clutter_actor_hide ((ClutterActor*) _tmp77_);
#line 149 "../src/Widgets/WindowOverview.vala"
				_tmp78_ = window;
#line 149 "../src/Widgets/WindowOverview.vala"
				_tmp79_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (_tmp78_));
#line 149 "../src/Widgets/WindowOverview.vala"
				container = G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 150 "../src/Widgets/WindowOverview.vala"
				_tmp80_ = container;
#line 150 "../src/Widgets/WindowOverview.vala"
				if (_tmp80_ == NULL) {
#line 151 "../src/Widgets/WindowOverview.vala"
					continue;
#line 1076 "WindowOverview.c"
				}
#line 154 "../src/Widgets/WindowOverview.vala"
				_tmp81_ = container;
#line 154 "../src/Widgets/WindowOverview.vala"
				_tmp82_ = window;
#line 154 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_add_window (_tmp81_, _tmp82_);
#line 155 "../src/Widgets/WindowOverview.vala"
				_tmp83_ = container;
#line 155 "../src/Widgets/WindowOverview.vala"
				_tmp84_ = display;
#line 155 "../src/Widgets/WindowOverview.vala"
				_tmp85_ = meta_display_get_focus_window (_tmp84_);
#line 155 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_open (_tmp83_, _tmp85_, FALSE, FALSE);
#line 1092 "WindowOverview.c"
			}
		}
	}
#line 64 "../src/Widgets/WindowOverview.vala"
	(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 64 "../src/Widgets/WindowOverview.vala"
	window_ids = (g_free (window_ids), NULL);
#line 1100 "WindowOverview.c"
}

static gboolean
gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                        MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 170 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label0 = 0;
#line 170 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label1 = 0;
#line 170 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label2 = 0;
#line 1118 "WindowOverview.c"
	gboolean result;
#line 159 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 160 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 160 "../src/Widgets/WindowOverview.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 162 "../src/Widgets/WindowOverview.vala"
	switch (action) {
#line 162 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 162 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 1134 "WindowOverview.c"
		{
#line 165 "../src/Widgets/WindowOverview.vala"
			result = FALSE;
#line 165 "../src/Widgets/WindowOverview.vala"
			return result;
#line 1140 "WindowOverview.c"
		}
		default:
		{
#line 167 "../src/Widgets/WindowOverview.vala"
			break;
#line 1146 "WindowOverview.c"
		}
	}
#line 170 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 170 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = _tmp1_;
#line 170 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 170 "../src/Widgets/WindowOverview.vala"
	if (((_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("expose-all-windows")))) || (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("zoom-in"))))) || (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("zoom-out"))))) {
#line 170 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1159 "WindowOverview.c"
			default:
			{
#line 174 "../src/Widgets/WindowOverview.vala"
				result = FALSE;
#line 174 "../src/Widgets/WindowOverview.vala"
				return result;
#line 1166 "WindowOverview.c"
			}
		}
	} else {
#line 170 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1172 "WindowOverview.c"
			default:
			{
#line 176 "../src/Widgets/WindowOverview.vala"
				break;
#line 1177 "WindowOverview.c"
			}
		}
	}
#line 179 "../src/Widgets/WindowOverview.vala"
	result = TRUE;
#line 179 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1185 "WindowOverview.c"
}

static void
gala_window_overview_restack_windows (GalaWindowOverview* self)
{
	GList* _tmp0_;
#line 182 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1196 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 183 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp0_;
#line 183 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1204 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 183 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1208 "WindowOverview.c"
			{
				ClutterActor* _tmp1_;
#line 184 "../src/Widgets/WindowOverview.vala"
				_tmp1_ = child;
#line 184 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_restack_windows (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer));
#line 1215 "WindowOverview.c"
			}
		}
#line 183 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1220 "WindowOverview.c"
	}
}

static void
gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                          gint num,
                                          MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GList* _tmp2_;
#line 188 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 189 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, num);
#line 189 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 190 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 190 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 191 "../src/Widgets/WindowOverview.vala"
		return;
#line 1247 "WindowOverview.c"
	}
#line 195 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1251 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 195 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 195 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1259 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 195 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 195 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1266 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
#line 196 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 196 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp4_)) {
#line 1273 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp5_;
#line 197 "../src/Widgets/WindowOverview.vala"
					_tmp5_ = container;
#line 197 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_remove_window (_tmp5_, window);
#line 198 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 198 "../src/Widgets/WindowOverview.vala"
					break;
#line 1283 "WindowOverview.c"
				}
#line 195 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1287 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_add_window (GalaWindowOverview* self,
                                 MetaWindow* window)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWindowType _tmp3_;
	MetaWindowType _tmp4_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	MetaWindowType _tmp9_;
	MetaWindowType _tmp10_;
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp15_;
	GalaWindowCloneContainer* _tmp16_;
	GList* _tmp17_;
#line 203 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 204 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 204 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 204 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 205 "../src/Widgets/WindowOverview.vala"
		return;
#line 1322 "WindowOverview.c"
	}
#line 207 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_window_get_window_type (window);
#line 207 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = _tmp3_;
#line 207 "../src/Widgets/WindowOverview.vala"
	if (_tmp4_ == META_WINDOW_DOCK) {
#line 207 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = TRUE;
#line 1332 "WindowOverview.c"
	} else {
		MetaWindowType _tmp5_;
		MetaWindowType _tmp6_;
#line 208 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = meta_window_get_window_type (window);
#line 208 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = _tmp5_;
#line 208 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = _tmp6_ == META_WINDOW_NOTIFICATION;
#line 1342 "WindowOverview.c"
	}
#line 207 "../src/Widgets/WindowOverview.vala"
	if (_tmp2_) {
#line 209 "../src/Widgets/WindowOverview.vala"
		return;
#line 1348 "WindowOverview.c"
	}
#line 211 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_window_get_window_type (window);
#line 211 "../src/Widgets/WindowOverview.vala"
	_tmp10_ = _tmp9_;
#line 211 "../src/Widgets/WindowOverview.vala"
	if (_tmp10_ != META_WINDOW_NORMAL) {
#line 1356 "WindowOverview.c"
		MetaWindowType _tmp11_;
		MetaWindowType _tmp12_;
#line 212 "../src/Widgets/WindowOverview.vala"
		_tmp11_ = meta_window_get_window_type (window);
#line 212 "../src/Widgets/WindowOverview.vala"
		_tmp12_ = _tmp11_;
#line 212 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = _tmp12_ != META_WINDOW_DIALOG;
#line 1365 "WindowOverview.c"
	} else {
#line 211 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = FALSE;
#line 1369 "WindowOverview.c"
	}
#line 211 "../src/Widgets/WindowOverview.vala"
	if (_tmp8_) {
#line 211 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = TRUE;
#line 1375 "WindowOverview.c"
	} else {
#line 213 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = meta_window_is_attached_dialog (window);
#line 1379 "WindowOverview.c"
	}
#line 211 "../src/Widgets/WindowOverview.vala"
	if (_tmp7_) {
#line 1383 "WindowOverview.c"
		MetaWindowActor* actor = NULL;
		GObject* _tmp13_;
		MetaWindowActor* _tmp14_;
#line 214 "../src/Widgets/WindowOverview.vala"
		_tmp13_ = meta_window_get_compositor_private (window);
#line 214 "../src/Widgets/WindowOverview.vala"
		actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, meta_window_actor_get_type (), MetaWindowActor);
#line 215 "../src/Widgets/WindowOverview.vala"
		_tmp14_ = actor;
#line 215 "../src/Widgets/WindowOverview.vala"
		clutter_actor_hide ((ClutterActor*) _tmp14_);
#line 217 "../src/Widgets/WindowOverview.vala"
		return;
#line 1397 "WindowOverview.c"
	}
#line 220 "../src/Widgets/WindowOverview.vala"
	_tmp15_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 220 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 221 "../src/Widgets/WindowOverview.vala"
	_tmp16_ = container;
#line 221 "../src/Widgets/WindowOverview.vala"
	if (_tmp16_ == NULL) {
#line 222 "../src/Widgets/WindowOverview.vala"
		return;
#line 1409 "WindowOverview.c"
	}
#line 226 "../src/Widgets/WindowOverview.vala"
	_tmp17_ = self->priv->workspaces;
#line 1413 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 226 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp17_;
#line 226 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1421 "WindowOverview.c"
			MetaWorkspace* _tmp18_;
			MetaWorkspace* workspace = NULL;
#line 226 "../src/Widgets/WindowOverview.vala"
			_tmp18_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 226 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp18_;
#line 1428 "WindowOverview.c"
			{
				MetaWorkspace* _tmp19_;
#line 227 "../src/Widgets/WindowOverview.vala"
				_tmp19_ = workspace;
#line 227 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp19_)) {
#line 1435 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp20_;
#line 228 "../src/Widgets/WindowOverview.vala"
					_tmp20_ = container;
#line 228 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_add_window (_tmp20_, window);
#line 229 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 229 "../src/Widgets/WindowOverview.vala"
					break;
#line 1445 "WindowOverview.c"
				}
#line 226 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1449 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_remove_window (GalaWindowOverview* self,
                                    MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GalaWindowCloneContainer* _tmp2_;
#line 234 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 235 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 235 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 236 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 236 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 237 "../src/Widgets/WindowOverview.vala"
		return;
#line 1477 "WindowOverview.c"
	}
#line 240 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = container;
#line 240 "../src/Widgets/WindowOverview.vala"
	gala_window_clone_container_remove_window (_tmp2_, window);
#line 1483 "WindowOverview.c"
}

static Block70Data*
block70_data_ref (Block70Data* _data70_)
{
#line 243 "../src/Widgets/WindowOverview.vala"
	g_atomic_int_inc (&_data70_->_ref_count_);
#line 243 "../src/Widgets/WindowOverview.vala"
	return _data70_;
#line 1493 "WindowOverview.c"
}

static void
block70_data_unref (void * _userdata_)
{
	Block70Data* _data70_;
	_data70_ = (Block70Data*) _userdata_;
#line 243 "../src/Widgets/WindowOverview.vala"
	if (g_atomic_int_dec_and_test (&_data70_->_ref_count_)) {
#line 1503 "WindowOverview.c"
		GalaWindowOverview* self;
#line 243 "../src/Widgets/WindowOverview.vala"
		self = _data70_->self;
#line 243 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (_data70_->window);
#line 243 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self);
#line 243 "../src/Widgets/WindowOverview.vala"
		g_slice_free (Block70Data, _data70_);
#line 1513 "WindowOverview.c"
	}
}

static gboolean
___lambda152_ (Block70Data* _data70_)
{
	GalaWindowOverview* self;
	MetaWorkspace* _tmp0_;
	MetaDisplay* _tmp1_;
	gboolean result;
#line 251 "../src/Widgets/WindowOverview.vala"
	self = _data70_->self;
#line 252 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_window_get_workspace (_data70_->window);
#line 252 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_display (_data70_->window);
#line 252 "../src/Widgets/WindowOverview.vala"
	meta_workspace_activate_with_focus (_tmp0_, _data70_->window, meta_display_get_current_time (_tmp1_));
#line 253 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 253 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1536 "WindowOverview.c"
}

static gboolean
____lambda152__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda152_ (self);
#line 251 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1546 "WindowOverview.c"
}

static void
gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                     MetaWindow* window)
{
	Block70Data* _data70_;
	MetaWindow* _tmp0_;
	MetaWorkspace* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
#line 243 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 243 "../src/Widgets/WindowOverview.vala"
	_data70_ = g_slice_new0 (Block70Data);
#line 243 "../src/Widgets/WindowOverview.vala"
	_data70_->_ref_count_ = 1;
#line 243 "../src/Widgets/WindowOverview.vala"
	_data70_->self = g_object_ref (self);
#line 243 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 243 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (_data70_->window);
#line 243 "../src/Widgets/WindowOverview.vala"
	_data70_->window = _tmp0_;
#line 244 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_workspace (_data70_->window);
#line 244 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 244 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 244 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 244 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 244 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == _tmp5_) {
#line 1588 "WindowOverview.c"
		MetaDisplay* _tmp6_;
#line 245 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = meta_window_get_display (_data70_->window);
#line 245 "../src/Widgets/WindowOverview.vala"
		meta_window_activate (_data70_->window, meta_display_get_current_time (_tmp6_));
#line 246 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 1596 "WindowOverview.c"
	} else {
#line 248 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 251 "../src/Widgets/WindowOverview.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ____lambda152__gsource_func, block70_data_ref (_data70_), block70_data_unref);
#line 1602 "WindowOverview.c"
	}
#line 243 "../src/Widgets/WindowOverview.vala"
	block70_data_unref (_data70_);
#line 243 "../src/Widgets/WindowOverview.vala"
	_data70_ = NULL;
#line 1608 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
__lambda151_ (GalaWindowOverview* self)
{
	gboolean result;
#line 279 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_cleanup (self);
#line 281 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 281 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1624 "WindowOverview.c"
}

static gboolean
___lambda151__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda151_ ((GalaWindowOverview*) self);
#line 278 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1634 "WindowOverview.c"
}

static void
gala_window_overview_real_close (GalaActivatableComponent* base,
                                 GHashTable* hints)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GList* _tmp2_;
	GalaWindowManager* _tmp8_;
	MetaDisplay* _tmp9_;
	guint _tmp10_;
	GList* _tmp11_;
#line 261 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 262 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 262 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 262 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 263 "../src/Widgets/WindowOverview.vala"
		return;
#line 1659 "WindowOverview.c"
	}
#line 266 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_restack_windows (self);
#line 268 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1665 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 268 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 268 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1673 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 268 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 268 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1680 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
				guint _tmp5_;
				MetaWorkspace* _tmp6_;
				guint _tmp7_;
#line 269 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 269 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp5_, NULL, FALSE);
#line 269 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self);
#line 270 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = workspace;
#line 270 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp7_, NULL, FALSE);
#line 270 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self);
#line 268 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1700 "WindowOverview.c"
			}
		}
	}
#line 272 "../src/Widgets/WindowOverview.vala"
	_tmp8_ = self->priv->_wm;
#line 272 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_plugin_get_display ((MetaPlugin*) _tmp8_);
#line 272 "../src/Widgets/WindowOverview.vala"
	g_signal_parse_name ("window-left-monitor", meta_display_get_type (), &_tmp10_, NULL, FALSE);
#line 272 "../src/Widgets/WindowOverview.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self);
#line 274 "../src/Widgets/WindowOverview.vala"
	_tmp11_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1714 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 274 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp11_;
#line 274 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1722 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 274 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1726 "WindowOverview.c"
			{
				ClutterActor* _tmp12_;
#line 275 "../src/Widgets/WindowOverview.vala"
				_tmp12_ = child;
#line 275 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_close (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer), FALSE, FALSE);
#line 1733 "WindowOverview.c"
			}
		}
#line 274 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1738 "WindowOverview.c"
	}
#line 278 "../src/Widgets/WindowOverview.vala"
	clutter_threads_add_timeout ((guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ___lambda151__gsource_func, self);
#line 1742 "WindowOverview.c"
}

static void
gala_window_overview_cleanup (GalaWindowOverview* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	GList* _tmp6_;
#line 285 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 288 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 288 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = self->priv->modal_proxy;
#line 288 "../src/Widgets/WindowOverview.vala"
	gala_window_manager_pop_modal (_tmp0_, _tmp1_);
#line 290 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 290 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 290 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 290 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 290 "../src/Widgets/WindowOverview.vala"
	_tmp6_ = meta_workspace_list_windows (_tmp5_);
#line 1775 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 290 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp6_;
#line 290 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1783 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 290 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1787 "WindowOverview.c"
			{
				MetaWindow* _tmp7_;
#line 291 "../src/Widgets/WindowOverview.vala"
				_tmp7_ = window;
#line 291 "../src/Widgets/WindowOverview.vala"
				if (meta_window_showing_on_its_workspace (_tmp7_)) {
#line 1794 "WindowOverview.c"
					MetaWindow* _tmp8_;
					GObject* _tmp9_;
#line 292 "../src/Widgets/WindowOverview.vala"
					_tmp8_ = window;
#line 292 "../src/Widgets/WindowOverview.vala"
					_tmp9_ = meta_window_get_compositor_private (_tmp8_);
#line 292 "../src/Widgets/WindowOverview.vala"
					clutter_actor_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, clutter_actor_get_type (), ClutterActor));
#line 1803 "WindowOverview.c"
				}
			}
		}
#line 290 "../src/Widgets/WindowOverview.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1809 "WindowOverview.c"
	}
#line 296 "../src/Widgets/WindowOverview.vala"
	clutter_actor_destroy_all_children ((ClutterActor*) self);
#line 1813 "WindowOverview.c"
}

GalaWindowManager*
gala_window_overview_get_wm (GalaWindowOverview* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 13 "../src/Widgets/WindowOverview.vala"
	result = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1829 "WindowOverview.c"
}

static void
gala_window_overview_set_wm (GalaWindowOverview* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	old_value = gala_window_overview_get_wm (self);
#line 13 "../src/Widgets/WindowOverview.vala"
	if (old_value != value) {
#line 1843 "WindowOverview.c"
		GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 13 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self->priv->_wm);
#line 13 "../src/Widgets/WindowOverview.vala"
		self->priv->_wm = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY]);
#line 1853 "WindowOverview.c"
	}
}

static GObject *
gala_window_overview_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowOverview * self;
#line 24 "../src/Widgets/WindowOverview.vala"
	parent_class = G_OBJECT_CLASS (gala_window_overview_parent_class);
#line 24 "../src/Widgets/WindowOverview.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 24 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 25 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 26 "../src/Widgets/WindowOverview.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 24 "../src/Widgets/WindowOverview.vala"
	return obj;
#line 1877 "WindowOverview.c"
}

static void
gala_window_overview_class_init (GalaWindowOverviewClass * klass,
                                 gpointer klass_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Widgets/WindowOverview.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowOverview_private_offset);
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_key_press_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->button_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_button_release_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_overview_get_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_overview_set_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_overview_constructor;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_overview_finalize;
#line 8 "../src/Widgets/WindowOverview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_OVERVIEW_WM_PROPERTY, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1902 "WindowOverview.c"
}

static void
gala_window_overview_gala_activatable_component_interface_init (GalaActivatableComponentIface * iface,
                                                                gpointer iface_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_gala_activatable_component_parent_iface = g_type_interface_peek_parent (iface);
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->is_opened = (gboolean (*) (GalaActivatableComponent*)) gala_window_overview_real_is_opened;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->open = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_open;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->close = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_close;
#line 1917 "WindowOverview.c"
}

static void
gala_window_overview_instance_init (GalaWindowOverview * self,
                                    gpointer klass)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	self->priv = gala_window_overview_get_instance_private (self);
#line 1926 "WindowOverview.c"
}

static void
gala_window_overview_finalize (GObject * obj)
{
	GalaWindowOverview * self;
#line 8 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 13 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->_wm);
#line 15 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 17 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 18 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->window_clone_container);
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (gala_window_overview_parent_class)->finalize (obj);
#line 1945 "WindowOverview.c"
}

static GType
gala_window_overview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowOverviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_overview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowOverview), 0, (GInstanceInitFunc) gala_window_overview_instance_init, NULL };
	static const GInterfaceInfo gala_activatable_component_info = { (GInterfaceInitFunc) gala_window_overview_gala_activatable_component_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_overview_type_id;
	gala_window_overview_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowOverview", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_overview_type_id, GALA_TYPE_ACTIVATABLE_COMPONENT, &gala_activatable_component_info);
	GalaWindowOverview_private_offset = g_type_add_instance_private (gala_window_overview_type_id, sizeof (GalaWindowOverviewPrivate));
	return gala_window_overview_type_id;
}

GType
gala_window_overview_get_type (void)
{
	static volatile gsize gala_window_overview_type_id__once = 0;
	if (g_once_init_enter (&gala_window_overview_type_id__once)) {
		GType gala_window_overview_type_id;
		gala_window_overview_type_id = gala_window_overview_get_type_once ();
		g_once_init_leave (&gala_window_overview_type_id__once, gala_window_overview_type_id);
	}
	return gala_window_overview_type_id__once;
}

static void
_vala_gala_window_overview_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		g_value_set_object (value, gala_window_overview_get_wm (self));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1988 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1994 "WindowOverview.c"
	}
}

static void
_vala_gala_window_overview_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		gala_window_overview_set_wm (self, g_value_get_object (value));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2014 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2020 "WindowOverview.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 2035 "WindowOverview.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 2039 "WindowOverview.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 2043 "WindowOverview.c"
}

